/************************************************************************
 *									*
 *		qr|QRQbCu				*
 *									*
 *				: ^C}[				*
 *		t@C	: timer.c				*
 *		쐬		: s.aizawa				*
 *									*
 ************************************************************************/

#include	<stddef.h>
#include	<stdlib.h>
#include	<dos.h>
#include	<conio.h>
#include	"rs232c.h"

/*	^C}[[NGA`	*/
struct	timer	{
	int	no;
	int	counter;
	struct	timer	*chain;
};
typedef	struct	timer	TIMER;

/*	֐	*/
static	void	interrupt far	tm_intr(void);

/*	X^eBbNϐ	*/
static	int	open_flag;
static	TIMER	*tm_top;
static	void	(interrupt far *tm_vect)();

/*	POJE^[ */
long	tm_counter;

#pragma	check_stack-		/* X^bN`FbN */

/*=======================================================================
 |
 |		^C}[gp
 |
 |	int	tm_open()
 |
 |		Ԓl			OF@@PFI[vς
 |
 =======================================================================*/
int	tm_open(void)
{
	char	far *fptr;

	if (open_flag != 0)
		return(1);

	/* 荞݃xN^Zbg */
	tm_vect = _dos_getvect(0x08);
	_dos_setvect(0x08, tm_intr);

	/* ^C}[N */
	FP_SEG(fptr) = 0;
	FP_OFF(fptr) = 0x501;
	(void)outp(IOP_TMC_CWW, 0x36);
	(void)outp(IOP_TMC_C0L, 0x00);
	(void)outp(IOP_TMC_C0L, *fptr & 0x80 ? 0x4e : 0x60);
	(void)outp(IOP_ICM_IMR, inp(IOP_ICM_IMR) & 0xfe);

	tm_counter = 0L;	/* POJE^[NA */

	open_flag = 1;		/* I[vtOZbg */

	return(0);
}

/*=======================================================================
 |
 |		^C}[Zbg
 |
 |	int	tm_set(no, tm)
 |
 |		int	no;		^C}[ԍ
 |		int	tm;		^C}[liPOPʁj
 |
 |		Ԓl			OF
 |					PFI[v
 |					QF[NGAmێs
 |
 =======================================================================*/
int	tm_set(int no, int tm)
{
	TIMER	*tp;

	if (open_flag == 0)
		return(1);

	_disable();

	/* [NGAT[` */
	for (tp = tm_top; tp != NULL; tp = tp->chain) {
		if (tp->no == no)
			break;
	}

	if (tp == NULL) {
		/* [NGAm */
		if ((tp = malloc(sizeof(TIMER))) == NULL) {
			_enable();
			return(2);
		}

		/* [NGAɃZbg */
		tp->no = no;
		tp->chain = tm_top;
		tm_top = tp;
	}

	tp->counter = tm;

	_enable();

	return(0);
}

/*=======================================================================
 |
 |		^CAEg`FbN
 |
 |	int	tm_check(no)
 |
 |		int	no;		^C}[ԍ
 |
 |		Ԓl			OF^CAEgĂȂ
 |					PF^CAEg
 |					@@i^C}[ZbgĂȂj
 |
 =======================================================================*/
int	tm_check(int no)
{
	TIMER	*tp;

	/* [NGAT[` */
	for (tp = tm_top; tp != NULL; tp = tp->chain) {
		if (tp->no == no) {
			if (tp->counter == 0) {
				tm_stop(no);
				return(1);
			} else
				return(0);
		}
	}

	return(1);
}

/*=======================================================================
 |
 |		^C}[~
 |
 |	void	tm_stop(no)
 |
 |		int	no;		^C}[ԍ
 |
 =======================================================================*/
void	tm_stop(int no)
{
	TIMER	*tp, **tpp;

	/* [NGAT[`A */
	_disable();
	for (tpp = &tm_top; *tpp != 0; tpp = &(*tpp)->chain) {
		if ((*tpp)->no == no) {
			tp = *tpp;
			*tpp = (*tpp)->chain;
			free(tp);
			break;
		}
	}
	_enable();
}

/*=======================================================================
 |
 |		^C}[gpI
 |
 |	void	tm_close()
 |
 =======================================================================*/
void	tm_close(void)
{
	if (open_flag == 0)
		return;

	/* SẴ^C}[I */
	while (tm_top != NULL)
		tm_stop(tm_top->no);

	/* 荞݃xN^ɖ߂ */
	_disable();
	(void)outp(IOP_ICM_IMR, inp(IOP_ICM_IMR) | 0x01);
	_dos_setvect(0x08, tm_vect);
	_enable();

	open_flag = 0;
}

/*=======================================================================
 |
 |		^C}[荞ݏ
 |
 |	void	interrupt far	tm_intr()
 |
 =======================================================================*/
static	void	interrupt far	tm_intr(void)
{
	TIMER	*tp;

	for (tp = tm_top; tp != NULL; tp = tp->chain) {
		if (tp->counter != 0)
			tp->counter--;	/* ^C}[JEg_E */
	}

	tm_counter++;		/* POJE^[XV */

	/* 荞ݏIʒm */
	(void)outp(IOP_ICM_EOI, 0x20);
}
